/*************************************************************************************************************   
 Copyright:	Inverse groupe conseil, 2006 
 Author: 		Robert Bolduc
 Email:		support@inverse.ca 
 URL:			http://inverse.ca
  
 This file is part of "Addressbook GroupDAV Connector" a Thunderbird extension.

    "Addressbook GroupDAV Connector" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as published by
    the Free Software Foundation;

    "Addressbook GroupDAV Connector" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "Addressbook GroupDAV Connector"; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ********************************************************************************/

const LOCAL_UPDATE_FLAG = ".local"; // append to version number when the update is done offline
const LOCAL_DELETE_FLAG = ".deleted";

var groupdavTypes ={
	GroupDAV_Generic : 0
};

function getModifiedLocalVersion(versionString){
	if (!versionString){
		return null;
	}
 	var localUpdatePos = versionString.indexOf(LOCAL_UPDATE_FLAG);
   if (localUpdatePos != -1)
   // There is a local update
      return versionString.substr(0, localUpdatePos);
   else
   		return null; 
}

function getDeletedLocalVersion(versionString){
 	var localUpdatePos = versionString.indexOf(LOCAL_DELETE_FLAG);
   if (localUpdatePos != -1)
   // There is a local update
      return versionString.substr(0, localUpdatePos);
   else
   		return null; 
}

function GroupdavServerFactory(){}
GroupdavServerFactory.get = function(type){  
	switch(type){
	case groupdavTypes.GroupDAV_Generic:
		return new SogoImpl();
	default:
		throw "Server type " + type + " is not supported";
	}
}

/******************************************
 * Class SogoImpl
 ******************************************/	
function SogoImpl(){}
	
/******************************************
 * Static public properties
 ******************************************/


SogoImpl.pseudoGUID = function(){
	var guid = "";
	for (var i = 1; i <= 18; i++){
		var n = Math.floor(Math.random() * 16.0).toString(16);
		guid += n;
		if ((i == 8) || (i == 12) || (i == 16) || (i == 20)){
			guid += "-";
		}			
	 }
	 return guid	
}
	
/*********************************************
 * function getServerVcardHrefList(doc)
 * 
 * doc: nsIDOMDocument 
 * returns an Array
 * *******************************************/
SogoImpl.prototype.getServerVcardHrefList = function(doc){
   var nodeList = doc.getElementsByTagName("getcontenttype");
   logDebug("getServerVcardHrefList size :" + nodeList.length);
   var cleanedNodes = new Array();
   var k = 0;
   for (var i=0; i<nodeList.length; i++){	
      if (nodeList[i].firstChild.nodeValue.search("text/x-vcard") != -1){
         cleanedNodes[k]=nodeList[i].parentNode.getElementsByTagName("href")[0];
         k++;
      }
   }
   logDebug("getServerVcardHrefList return size :" + cleanedNodes.length);
   return cleanedNodes;
}

SogoImpl.prototype.getKey = function(href) {
   var elems = href.textContent.split("/");
   return elems[elems.length - 1];
}

SogoImpl.prototype.getVersion = function(hrefNode){
	return hrefNode.parentNode.getElementsByTagName("getetag")[0].firstChild.nodeValue;		
}

SogoImpl.prototype.getNewCardKey = function(){
	return "AA-" + SogoImpl.pseudoGUID();
}
