/*************************************************************************************************************   
 Copyright:	Inverse groupe conseil, 2006 
 Author: 		Robert Bolduc
 Email:		support@inverse.ca 
 URL:			http://inverse.ca
  
 This file is part of "Addressbook GroupDAV Connector" a Thunderbird extension.

    "Addressbook GroupDAV Connector" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as published by
    the Free Software Foundation;

    "Addressbook GroupDAV Connector" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "Addressbook GroupDAV Connector"; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ********************************************************************************/

var gRdfService;
var gCurrentDirectory = null;
var gCurrentDirectoryURI;

function onAccept(){
	var abWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mail:addressbook");	
	try{
		//There has to be at least a description to create a SOGO addressbook
		var description = document.getElementById("description").value;
		if(!description && description == ""){
			alert("Cannot create an Addressbook without a name");
			return;
		}
		var properties;
		var addressbook = Components.classes["@mozilla.org/addressbook;1"].createInstance(Components.interfaces.nsIAddressBook);		
		if (gCurrentDirectory == null || gCurrentDirectory.dirPrefId == ""){
		// adding a new Addressbook		
			properties = Components.classes["@mozilla.org/addressbook/properties;1"].createInstance(Components.interfaces.nsIAbDirectoryProperties);
			properties.dirType = 2;// ???don't know which values should go in there but 2 seems to get the job done
			properties.description = description;
	      addressbook.newAddressBook(properties);
	      	
	      gCurrentDirectoryURI = properties.URI;
			gCurrentDirectory = gRdfService.GetResource(gCurrentDirectoryURI).QueryInterface(Components.interfaces.nsIAbDirectory);
		}else{
		// Modifying existing Addressbook
			properties = gCurrentDirectory.directoryProperties; 
			properties.description = description;
			gCurrentDirectory.dirName = description;
			var addressbookDS = gRdfService.GetDataSource("rdf:addressdirectory");
		   // moz-abdirectory:// is the RDF root to get all types of addressbooks.
		   var parentDir = gRdfService.GetResource("moz-abdirectory://").QueryInterface(Components.interfaces.nsIAbDirectory);
			addressbook.modifyAddressBook(addressbookDS, parentDir, gCurrentDirectory, properties);   		
		}
		var groupdavPrefService = new GroupdavPreferenceService(gCurrentDirectory.dirPrefId);
		groupdavPrefService.setURL(document.getElementById("groupdavURL").value);
		groupdavPrefService.setDirectoryName(description);
		groupdavPrefService.setDisplayDialog(document.getElementById("displaySynchCompleted").getAttribute("checked"));

		window.opener.gNewServerString = gCurrentDirectoryURI;
	  	window.opener.gNewServer = description;
	  	// set window.opener.gUpdate to true so that SOGO Directory Servers dialog gets updated
	  	window.opener.gUpdate = true;
	}catch (e){
		abWindow.exceptionHandler(window,"Preference onLoad()",e);
	}
  	window.close();
} 

function onLoad(){
	var abWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mail:addressbook");
	try{
		gRdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);	
		if ( "arguments" in window && window.arguments[0] ) {
			gCurrentDirectoryURI = window.arguments[0];
			gCurrentDirectory = gRdfService.GetResource(gCurrentDirectoryURI).QueryInterface(Components.interfaces.nsIAbDirectory);

		var groupdavPrefService = new GroupdavPreferenceService(gCurrentDirectory.dirPrefId);  
	   document.getElementById("description").value = gCurrentDirectory.dirName;
	   document.getElementById("groupdavURL").value = groupdavPrefService.getURL();
	   document.getElementById("displaySynchCompleted").setAttribute("checked", groupdavPrefService.getDisplayDialog());
		}
	   
	}catch (e){
		throw e;
	}
}

function onUnload(){
}

function fillDialog(){
}

//TODO:catch the directory delete and delete preferences

function onCancel(){
	window.close();
}
